(setf *BASEPITCH* 6.09)
(setf *MEASURE* 1.0)
(setf e (/ *MEASURE* 6.0))
(setf q (* e 2))
(setf dq (* e 3))

; unit definitions
; for types:  s == "straight"; b == "bend" v == "vibrato" c == "chord"

; unit1 definition
(put 'unit1 'nnotes 6)
(put 'unit1 'pitches '(0.07 0.10 0.12 0.07 0.10 0.12))
(put 'unit1 'durations '(e e e e e e))
(put 'unit1 'rhythms '(e e e e e e))
(put 'unit1 'types '(s s s s s s))

; unit2 definition
(put 'unit2 'nnotes 2)
(put 'unit2 'pitches '(0.00 -0.02))
(put 'unit2 'durations '(e dq))
(put 'unit2 'rhythms '(dq dq))
(put 'unit2 'types '(s v))

; unit3 definition
(put 'unit3 'nnotes 4)
(put 'unit3 'pitches '(0.12 0.12 0.14 0.10))
(put 'unit3 'durations '(e e q e))
(put 'unit3 'rhythms '(q e q e))
(put 'unit3 'types '(s s b s))

; unit4 definition
(put 'unit4 'nnotes 4)
(put 'unit4 'pitches '(0.00 0.00 0.00 0.00))
(put 'unit4 'pitches2 '(0.07 0.07 0.09 0.09))
(put 'unit4 'durations '(e e e e))
(put 'unit4 'rhythms '(q e q e))
(put 'unit4 'types '(c c c c))

; unit5 definition
(put 'unit5 'nnotes 4)
(put 'unit5 'pitches '(0.00 0.00 0.00 0.00))
(put 'unit5 'pitches2 '(0.10 0.10 0.09 0.09))
(put 'unit5 'durations '(e e e e))
(put 'unit5 'rhythms '(q e q e))
(put 'unit5 'types '(c c c c))

(defun makefuncs()
	(princ "vib = makeLFO(\"sine\", 4, 0, 0.005)")
	(terpri)
	(princ "bend = maketable(\"line\", \"nonorm\", 1000, 0, 0, 1, 0.01)")
)

(defun vibwrite(pitch)
	(concatenate 'string (write-to-string pitch) "+vib")
)

(defun bendwrite(pitch)
	(concatenate 'string (write-to-string pitch) "+bend")
)

(defun makenotes(a_unit) (prog(notesdone the_pitch the_rhy the_dur start the_type)
	(setf notesdone 0)
	(setf start 0)
again  (setf the_pitch (nth notesdone (get a_unit 'pitches)))
	(setf the_pitch (mus-add *BASEPITCH* the_pitch))
	(setf the_dur (eval (nth notesdone (get a_unit 'durations))))
	(setf the_type (nth notesdone (get a_unit 'types)))

	(cond ((eq the_type 's)
					(cmix-print 'STRUMFB `(,start ,the_dur 20000 ,the_pitch ,the_pitch 3 ,the_dur ,the_dur 100.0 0.1 0 1 0.5)))
			((eq the_type 'v)
					(cmix-print 'STRUMFB `(,start ,the_dur 20000 ,(vibwrite the_pitch) ,the_pitch 3 ,the_dur ,the_dur 100.0 0.1 0 1 0.5)))
			((eq the_type 'b)
					(cmix-print 'STRUMFB `(,start ,the_dur 20000 ,(bendwrite the_pitch) ,the_pitch 3 ,the_dur ,the_dur 100.0 0.1 0 1 0.5)))
			((eq the_type 'c)
					(cmix-print 'STRUMFB `(,start ,the_dur 20000 ,the_pitch ,the_pitch 3 ,the_dur ,the_dur 100.0 0.1 0 1 0.5))
					(setf the_pitch (nth notesdone (get a_unit 'pitches2)))
					(setf the_pitch (mus-add *BASEPITCH* the_pitch))
					(cmix-print 'STRUMFB `(,start ,the_dur 20000 ,the_pitch ,the_pitch 3 ,the_dur ,the_dur 100.0 0.1 0 1 0.5))
			)
	)

	(setf the_rhy (eval (nth notesdone (get a_unit 'rhythms))))
	(setf start (+ start the_rhy))

	(setf notesdone (+ notesdone 1))
	(cond ((= notesdone (get a_unit 'nnotes)) (return t)) )
	(go again)
	)
)

